#include "pg.h"
#include "font.c"

#define TARGETPATH "ms0:/PSP/GAME/RIN/ROM.GB"

// ---------------------------------------------------------------------------------

#define K_SHIFT		1
#define K_RIGHT		2
#define K_DOWN		3
#define K_LEFT		4
#define K_DEL		5
#define K_SYMBL		6
#define	K_MEMO		7
#define K_UP		8
#define K_TODO		9
#define K_ENTER		10
#define K_PHONE		11
#define K_CANCL		12
#define K_DATE		13
#define K_BS		14
#define K_ALT		15
#define K_FN		16
#define K_CTRL		17
#define K_TAB		18
#define K_CAPS		19
#define K_CMND		20

unsigned char kbd_table[] = {
//     +0      +1      +2      +3      +4      +5      +6      +7      +8      +9      +A      +B      +C      +D      +E      +F
        0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,
        0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,      0,
      'P',    'O',    '1',    '3',      0,      0,      0,K_SHIFT,K_SHIFT,      0,      0,      0,K_RIGHT, K_DOWN, K_LEFT,  K_DEL,
  K_SYMBL,    '.',    ',',    'M',      0, K_MEMO,   K_UP,    '/',    ';',    'L',    'K',    'J',      0, K_TODO,K_ENTER,   '\'',
        0,      0,    'I',    'U',K_PHONE,   '\\',    '[',    ']',K_CANCL,    '0',    '9',    '8', K_DATE,   K_BS,    '+',    '-',
      'N',    'B',    'V',    'C',      0,      0,      0,      0,      0,      0,      0,      0,  K_ALT,   K_FN,      0,      0,
        0,      0,      0,      0,      0, K_CTRL,  K_TAB, K_CAPS,    ' ',    'H',    'G',    'F',    'D',    'S',    'A',    'X',
      '`',    'Y',    'T',    'R',    'E',    'W',    'Q', K_CMND,    '7',    '6',    '5',    '4',    'Z',      0,    '2',      0
};






// ---------------------------------------------------------------------------------

unsigned short rgb2col(unsigned char r,unsigned char g,unsigned char b) {
	return ((((b>>3) & 0x1F)<<10)+(((g>>3) & 0x1F)<<5)+(((r>>3) & 0x1F)<<0)+0x8000);
}

char *mh_strncpy(char *s1,char *s2,int n) {
	char *rt = s1;

	while((*s2!=0) && ((n-1)>0)) {
		*s1 = *s2;
		s1++;
		s2++;
		n--;
	}
	*s1 = 0;

	return rt;
}

char *mh_strncat(char *s1,char *s2,int n) {
	char *rt = s1;

	while((*s1!=0) && ((n-1)>0)) {
		s1++;
		n--;
	}

	while((*s2!=0) && ((n-1)>0)) {
		*s1 = *s2;
		s1++;
		s2++;
		n--;
	}
	*s1 = 0;

	return rt;
}

int mh_strlen(char *s1) {
	int n = 0;

	while(*s1!=0) {
		n++;
		s1++;
	}
	return n;
}

// ---------------------------------------------------------------------------------

void wait_button(void) {
	ctrl_data_t ctl;
	int btn;

	btn=1;
	while(btn!=0){
		sceCtrlRead(&ctl,1);
		btn = ((ctl.buttons & 0xF000) != 0);
	}
	btn=0;
	while(btn==0){
		sceCtrlRead(&ctl,1);
		btn = ((ctl.buttons & 0xF000) != 0);
	}
}

// ---------------------------------------------------------------------------------

unsigned short num2elisa(unsigned short c) {
	if (c >= 4418) {
		return c + (0xda1 - 4418);
	} else if (c >= 1410) {
		return c + (0x20c - 1410);
	} else if (c >= 690) {
		return 0x6b;
	} else if (c >= 658) {
		return c + (0x1ec - 658);
	} else if (c >= 612) {
		return c + (0x1cb - 612);
	} else if (c >= 564) {
		return c + (0x1aa - 564);
	} else if (c >= 502) {
		return c + (0x192 - 502);
	} else if (c >= 470) {
		return c + (0x17a - 470);
	} else if (c >= 376) {
		return c + (0x124 - 376);
	} else if (c >= 282) {
		return c + (0xd1 - 282);
	} else if (c >= 252) {
		return c + (0xb7 - 252);
	} else if (c >= 220) {
		return c + (0x9d - 220);
	} else if (c >= 203) {
		return c + (0x93 - 203);
	} else if (c >= 187) {
		return 0x92;
	} else if (c >= 175) {
		return c + (0x8a - 203);
	} else if (c >= 153) {
		return c + (0x7b - 153);
	} else if (c >= 135) {
		return c + (0x74 - 135);
	} else if (c >= 119) {
		return c + (0x6c - 119);
	} else {
		return c;
	}
}

void Draw_Char_Hankaku(int x,int y,unsigned char ch,int col,int backcol,int fill) {
	unsigned short *vr;
	unsigned char  *fnt;
	unsigned char  pt;
	int x1,y1;

	// mapping
	if (ch<0x20) {
		ch = 0;
	} else if (ch<0x80) {
		ch -= 0x20;
	} else if (ch<0xa0) {
		ch = 0;
	} else {
		ch -= 0x40;
	}
	fnt = (unsigned char *)&hankaku_font10[ch*10];

	// draw
	vr = (unsigned short *)pgGetVramAddr(x,y);
	for(y1=0;y1<10;y1++) {
		pt = *fnt++;
		for(x1=0;x1<5;x1++) {
			if (pt & 1) {
				*vr = col;
			} else {
				if (fill) *vr = backcol;
			}
			vr++;
			pt = pt >> 1;
		}
		vr += LINESIZE-5;
	}
}

void Draw_Char_Zenkaku(int x,int y,unsigned char u,unsigned char d,int col,int backcol,int fill) {
	unsigned short *vr;
	unsigned short *fnt;
	unsigned short pt;
	int x1,y1;

	// mapping
	if (d > 0x7F) d--;
	if (u > 0x9F) u-=0x40;
	d -= 0x40; u -= 0x81;
	fnt = (unsigned short *)&zenkaku_font10[num2elisa(u*0xbc+d)*10];

	// draw
	vr = (unsigned short *)pgGetVramAddr(x,y);
	for(y1=0;y1<10;y1++) {
		pt = *fnt++;
		for(x1=0;x1<10;x1++) {
			if (pt & 1) {
				*vr = col;
			} else {
				if (fill) *vr = backcol;
			}
			vr++;
			pt = pt >> 1;
		}
		vr += LINESIZE-10;
	}
}

void mh_print(int x,int y,unsigned char *str,int col,int backcol,int fill) {
	unsigned char ch = 0,bef = 0;

	while(*str != 0) {
		ch = *str++;
		if (bef!=0) {
			Draw_Char_Zenkaku(x,y,bef,ch,col,backcol,fill);
			x+=10;
			bef=0;
		} else {
			if (((ch>=0x80) && (ch<0xa0)) || (ch>=0xe0)) {
				bef = ch;
			} else {
				Draw_Char_Hankaku(x,y,ch,col,backcol,fill);
				x+=5;
			}
		}
	}
}

// ---------------------------------------------------------------------------------
#define MAXDEPTH  16
#define MAXDIRNUM 1024
#define MAXPATH   0x108
#define PATHLIST_H 20
#define REPEAT_TIME 0x40000
#define BUFSIZE		65536

dirent_t		dlist[MAXDIRNUM];
int				dlist_num;
char			now_path[MAXPATH];
char			target[MAXPATH];
char			path_tmp[MAXPATH];
int				dlist_start;
int				dlist_curpos;
int				cbuf_start[MAXDEPTH];
int				cbuf_curpos[MAXDEPTH];
int				now_depth;
char			buf[BUFSIZE];

static unsigned long control_bef_ctl  = 0;
static unsigned long control_bef_tick = 0;

unsigned long Read_Key(void) {
	ctrl_data_t ctl;

	sceCtrlRead(&ctl,1);
	if (ctl.buttons == control_bef_ctl) {
		if ((ctl.frame - control_bef_tick) > REPEAT_TIME) {
			return control_bef_ctl;
		}
		return 0;
	}
	control_bef_ctl  = ctl.buttons;
	control_bef_tick = ctl.frame;
	return control_bef_ctl;
}

void Get_DirList(char *path) {
	int ret,fd;

	// Directory read
	fd = sceIoDopen(path);
	dlist_num = 0;
	ret = 1;
	while((ret>0) && (dlist_num<MAXDIRNUM)) {
		ret = sceIoDread(fd, &dlist[dlist_num]);
		if (dlist[dlist_num].name[0] == '.') continue;
		if (ret>0) dlist_num++;
	}
	sceIoDclose(fd);

	// fBNgXgG[`FbN
	if (dlist_start  >= dlist_num) { dlist_start  = dlist_num-1; }
	if (dlist_start  <  0)         { dlist_start  = 0;           }
	if (dlist_curpos >= dlist_num) { dlist_curpos = dlist_num-1; }
	if (dlist_curpos <  0)         { dlist_curpos = 0;           }
}

void Draw_All(void) {
	int			i,col;

	pgFillvram(0);

	// ݒn
	mh_strncpy(path_tmp,now_path,40);
	mh_print(0,0,path_tmp,rgb2col(255,255,255),0,0);

	// fBNgXg
	i = dlist_start;
	while (i<(dlist_start+PATHLIST_H)) {
		if (i<dlist_num) {
			col = rgb2col(255,255,255);
			if (dlist[i].type & TYPE_DIR) {
				col = rgb2col(255,255,0);
			}
			if (i==dlist_curpos) {
				col = rgb2col(255,0,0);
			}
			mh_strncpy(path_tmp,dlist[i].name,40);
			mh_print(32,((i-dlist_start)+2)*10,path_tmp,col,0,0);
		}
		i++;
	}
	pgScreenFlipV();
}

void Draw_Confirm(void) {
	pgFillvram(0);

	mh_print(40, 80,"t@C"   ,rgb2col(255,255,255),0,0);
	mh_print(50, 90,target         ,rgb2col(255,255,0)  ,0,0);
	mh_print(40,100,""         ,rgb2col(255,255,255),0,0);
	mh_print(50,110,TARGETPATH     ,rgb2col(255,255,0)  ,0,0);
	mh_print(40,120,"ɃRs[܂B낵łH",rgb2col(255,255,255),0,0);

	mh_print(40,160,"sF  LZF~",rgb2col(255,255,255),0,0);
	pgScreenFlipV();
}

int Confirm_Control(void) {
	unsigned long key;

	while(1) {
		while(1) {
			key = Read_Key();
			if (key != 0) break;
			pgWaitV();
		}

		if (key & CTRL_CIRCLE) {
			return 1;
		}
		if (key & CTRL_CROSS) {
			return 0;
		}
	}
}

int Control(void) {
	unsigned long key;
	int i;

	// wait key
	while(1) {
		key = Read_Key();
		if (key != 0) break;
		pgWaitV();
	}

	if (key & CTRL_UP) {
		if (dlist_curpos > 0) {
			dlist_curpos--;
			if (dlist_curpos < dlist_start) { dlist_start = dlist_curpos; }
		}
	}
	if (key & CTRL_DOWN) {
		if (dlist_curpos < (dlist_num-1)) {
			dlist_curpos++;
			if (dlist_curpos >= (dlist_start+PATHLIST_H)) { dlist_start++; }
		}
	}
	if (key & CTRL_LEFT) {
		dlist_curpos -= PATHLIST_H;
		if (dlist_curpos <  0)          { dlist_curpos = 0;           }
		if (dlist_curpos < dlist_start) { dlist_start = dlist_curpos; }
	}
	if (key & CTRL_RIGHT) {
		dlist_curpos += PATHLIST_H;
		if (dlist_curpos >= dlist_num) { dlist_curpos = dlist_num-1; }
		while (dlist_curpos >= (dlist_start+PATHLIST_H)) { dlist_start++; }
	}

	if (key & CTRL_CIRCLE) {
		if (dlist[dlist_curpos].type & TYPE_DIR) {
			if (now_depth<MAXDEPTH) {
				// pathړ
				mh_strncat(now_path,dlist[dlist_curpos].name,MAXPATH);
				mh_strncat(now_path,"/",MAXPATH);
				cbuf_start[now_depth] = dlist_start;
				cbuf_curpos[now_depth] = dlist_curpos;
				dlist_start  = 0;
				dlist_curpos = 0;
				now_depth++;
				return 1;
			}
		} else {
			//
			return 2;
/*			for(i=0;i<MAXPATH;i++) {
				if (dlist[dlist_curpos].name[i]==0) break;
			}
			if (i>2) {
				if (((dlist[dlist_curpos].name[i-3] & 0xDF) == '.') &&
				    ((dlist[dlist_curpos].name[i-2] & 0xDF) == 'G') &&
				    ((dlist[dlist_curpos].name[i-1] & 0xDF) == 'B')) {
					return 2;
				}
				i--;
			}*/
		}
	}
	if (key & CTRL_CROSS) {
		if (now_depth > 0) {
			// pathړ
			for(i=0;i<MAXPATH;i++) {
				if (now_path[i]==0) break;
			}
			i--;
			while(i>4) {
				if (now_path[i-1]=='/') {
					now_path[i]=0;
					break;
				}
				i--;
			}
			now_depth--;
			dlist_start  = cbuf_start[now_depth];
			dlist_curpos = cbuf_curpos[now_depth];
			return 1;
		}
	}
	
	return 0;
}

void CopyExecute(void) {
	int fd1,fd2,len;

	pgFillvram(0);
	mh_print(0,0,"Rs[Ă܂",0xFFFF,0,0);
	pgScreenFlipV();

	fd1 = sceIoOpen(target,O_RDONLY);
	fd2 = sceIoOpen(TARGETPATH,O_WRONLY | O_CREAT | O_TRUNC);
	while(1) {
		len = sceIoRead(fd1, buf, BUFSIZE);
		if (len == 0) break;
		sceIoWrite(fd2,buf,len);
	}
	sceIoClose(fd1);
	sceIoClose(fd2);
}


char testmsg1[]="\xFF\xFF\xFF\xFF\xFF\xFF\xFF\xFF";
char testmsg2[]="\x00\x00\x00\x00\x00\x00\x00\x00";

char hex[]="0123456789ABCDEF";

unsigned char ReadIr(int fd) {
	unsigned char chbuf[2];
	int len;

	while(1) {
		len = sceIoRead(fd, chbuf, 1);
		if (len == 0) {
			pgWaitV();
		} else {
			break;
		}
	}

	return chbuf[0];
}


int cur_x,cur_y;
unsigned char chvram[30*17];

void draw_chvram(int cur_x,int cur_y) {
	int x,y;
	int col;

	pgFillvram(0);
	for(y=0;y<17;y++) {
		for(x=0;x<30;x++) {
			if ((x==cur_x)&&(y==cur_y)) {
				if (chvram[y*30+x]!=0) {
					pgPutChar(x*16,y*16,0,rgb2col(192,192,192),chvram[y*30+x],1,1,2);
				} else {
					pgPutChar(x*16,y*16,0,rgb2col(192,192,192),' ',1,1,2);
				}
			} else {
				if (chvram[y*30+x]!=0) {
					pgPutChar(x*16,y*16,0xFFFF,0x0000,chvram[y*30+x],1,0,2);
				}
			}
				
		}
	}
	pgScreenFlipV();
}

void check_cursorpos(void) {
	int i;
	
	// cursor
	if (cur_x<0) {
		cur_x=29;
		cur_y--;
	}
	if (cur_x>=30) {
		cur_x=0;
		cur_y++;
	}
	if (cur_y<0) {
		cur_y=0;
	}
	if (cur_y>=17) {
		for(i=0;i<30*16;i++) {
			chvram[i] = chvram[i+30];
		}
		for(i=0;i<30;i++) {
			chvram[i+30*16] = 0;
		}
		cur_y=16;
	}
}

void put_chvram(unsigned char ch) {
	chvram[cur_y*30+cur_x] = ch;
	cur_x++;
	check_cursorpos();
	draw_chvram(cur_x,cur_y);
}



int xmain(void) {
	int fd;
	int i,key;
	int in_packet,press;
	unsigned char ch,kd;

	// Initialize
	pgInit();
	pgScreenFrame(2,0);
	sceCtrlInit(0);
	sceCtrlSetAnalogMode(0);

	//
	cur_x = 0; cur_y = 0;
	for(i=0;i<30*17;i++) chvram[i]=0;
	draw_chvram(cur_x,cur_y);

	in_packet = 0;
	fd = sceIoOpen("irda0:",O_RDWR);
	while(1) {
		ch = ReadIr(fd);
		if (in_packet) {
			if (ch == 0xC1) {
				in_packet = 0;
			} else {
				// ---------------------------------------------------------------
				if (ch & 0x80) {
					// Press
					press = 1;

					kd = kbd_table[ch & 0x7F];
					if (kd != 0) {
						if (kd < 0x20) {
							// special key
							switch(kd) {
							case K_RIGHT:
								cur_x++;
								check_cursorpos();
								break;
							case K_DOWN:
								cur_y++;
								check_cursorpos();
								break;
							case K_LEFT:
								cur_x--;
								check_cursorpos();
								break;
							case K_UP:
								cur_y--;
								check_cursorpos();
								break;
							case K_ENTER:
								cur_x=0;
								cur_y++;
								check_cursorpos();
								break;
							case K_BS:
								cur_x--;
								check_cursorpos();
								chvram[cur_x+cur_y*30]=0;
								break;
							}
							draw_chvram(cur_x,cur_y);
						} else {
							// key
							put_chvram(kd);
						}
					}
				} else {
					// Release
					press = 0;
				}
				// ---------------------------------------------------------------
			}
		} else {
			if (ch == 0xC0) {
				in_packet = 1;
			}
		}
	}
	sceIoClose(fd);

	return 0;
}
